Unit AMTSR_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure AMTSR(var IA :Array of Integer; var JA :Array of Integer;
                var AN :Array of Real; N :Integer; M :Integer;
                var IAT :Array of Integer; var JAT :Array of Integer;
                var ANT :Array of Real); 
implementation

procedure AMTSR(var IA :Array of Integer; var JA :Array of Integer;
                var AN :Array of Real; N :Integer; M :Integer;
                var IAT :Array of Integer; var JAT :Array of Integer;
                var ANT :Array of Real);
var
MH,NH,IAB,I,J,IAA,JP,K :Integer;
label
_10,_20,_30,_40,_50,_60;
begin

{           }
{       ,    RR()U. }
{           RR(). }


{   I -    N+1,    - }
{         J  N,      - }
{          ;    I }
{           ,   ; }

{   J -  ,       }
{              }
{          ,   ;     - }
{         ; }

{   N -  ,    -  }
{                J;    }
{        N    ; }

{    N -      (: ); }

{     -      (: ); }

{  I -    +1,    - }
{         J  N,       }
{         ;    I  }
{           ,   ; }

{  J -  ,       }
{              , }
{          ;      ; }

{  N -  ,    - }
{                J; }
{         N    ; }

MH := M+1;
NH := N+1;
for I:=2 to MH do
 begin
_10:
  IAT[I-1] := 0;
 end;

{       I       }
{        }

IAB := IA[NH-1]-1;

{            }

for I:=1 to IAB do
 begin
  J := JA[I-1]+2;
  if ( J <= MH ) 
   then IAT[J-1] := IAT[J-1]+1;
_20:
 end;

{         I    - }
{       ,     J   }
{       N }

IAT[0] := 1;
IAT[1] := 1;
if ( M = 1 ) 
 then goto _40;
for I:=3 to MH do
 begin
_30:
  IAT[I-1] := IAT[I-1]+IAT[I-2];
 end;

{            J  N }

_40:
for I:=1 to N do
 begin
  IAA := IA[I-1];
  IAB := IA[I+0]-1;
  if ( IAB < IAA ) 
   then goto _60;

{            }

  for JP:=IAA to IAB do
   begin
    J := JA[JP-1]+1;
    K := IAT[J-1];
    JAT[K-1] := I;
    ANT[K-1] := AN[JP-1];
_50:
    IAT[J-1] := K+1;
   end;
_60:
 end;
end;

end.
